package com.huimv.manager.service;

import com.huimv.manager.dao.entity.ImagePathEntity;

import java.util.List;

public interface IImageService {
    /**
     * @Method      : getLastImage
     * @Description : 
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/21       
     * @Time        : 20:56
     */
    ImagePathEntity getLastImage();

    /**
     * @Method      : getNextImage
     * @Description : 
     * @Params      : []
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/21       
     * @Time        : 20:56
     */
    ImagePathEntity getNextImage();

    /**
     * @Method      : getImageList
     * @Description : 
     * @Params      : [startDate, endDate]
     * @Return      : java.util.List<com.huimv.manager.dao.entity.ImagePathEntity>
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/22       
     * @Time        : 16:04
     */
    List<ImagePathEntity> getImageList(String startDate, String endDate,int pageNo,int pageSize,String catalog);

    /**
     * @Method      : getTotal
     * @Description : 
     * @Params      : [startDate, endDate]
     * @Return      : int
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/22       
     * @Time        : 16:48
     */
    int getTotal(String startDate, String endDate,String catalog);

    /**
     * @Method      : getExportImageList
     * @Description : 
     * @Params      : [startDate, endDate, imageIds]
     * @Return      : java.util.List
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/23       
     * @Time        : 16:50
     */
    List getExportImageList(String startDate, String endDate, String imageIds);

    /**
     * @Method      : getOneImage
     * @Description : 
     * @Params      : [type, imageId]
     * @Return      : com.alibaba.fastjson.JSONObject
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/23       
     * @Time        : 19:25
     */
    ImagePathEntity getOneImage(String type, int imageId, String catalog);

    /**
     * @Method      : getOneImageDetail
     * @Description : 读取一张图片详情
     * @Params      : [imageId]
     * @Return      : void
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/23       
     * @Time        : 19:42
     */
    ImagePathEntity getOneImageDetail(String imageId);


    List<ImagePathEntity> getExportImageList(String startDate, String endDate, String imageIds, String catalog);


    int getTotal(String startDate, String endDate);

    /**
     * @Method      : autoUpdateImage
     * @Description : 自动更新图像名称
     * @Params      : []
     * @Return      : boolean
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/28       
     * @Time        : 15:23
     */
    boolean autoUpdateImage(Integer id,String type);
}
