package com.huimv.manager.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.huimv.manager.dao.entity.ImagePathEntity;
import com.huimv.manager.dao.repo.ImagePathRepo;
import com.huimv.manager.service.IImageService;
import com.huimv.manager.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
public class ImageServiceImpl implements IImageService {
    @Autowired
    private ImagePathRepo imagePathRepo;
    @Autowired
    private DateUtil dateUtil;

    @Override
    public boolean autoUpdateImage(Integer id,String type) {
        List<ImagePathEntity> imageEntityList = new ArrayList<>();
        if(type !=null && type.trim().equalsIgnoreCase("one")){
            // 读取更新图片
            imageEntityList = imagePathRepo.getOneUpdateImage(id);
        }else{
            // 读取更新图片
            imageEntityList = imagePathRepo.getAllUpdateImage(id);
        }
        for(ImagePathEntity imageEntity:imageEntityList){
            // 更新图片名称
            if(!updateImage(imageEntity)){
                System.out.println("【图片更新名称出错】");
            }else{
                // 更新图片表
                System.out.println(" 【更新后的图片信息】"+imageEntity);
                imagePathRepo.saveAndFlush(imageEntity);
            }
        }
        return true;
    }

    private boolean updateImage(ImagePathEntity imageEntity) {
        String fileName = imageEntity.getFileName();
        String relativePath = imageEntity.getRelativePath();
        String imgPath = imageEntity.getImgPath();
        String camera = imageEntity.getName();

        System.out.println("【fileName】"+fileName);
        System.out.println("【relativePath】"+relativePath);
        System.out.println("【imgPath】"+imgPath);
        System.out.println("【camera】"+camera);

        if(imgPath.indexOf("/"+camera+"/") == -1){
            System.out.println("----------------------【未分摄像头保存的图片】----------------------");
            String[] fileArray = fileName.split("_");
            if(fileArray.length==2){
                String dateName = fileArray[1];
                System.out.println("【日期名称（包含图片扩展名）】"+dateName);
                String[] dateNameArray = dateName.split("\\.");
                System.out.println("dateNameArray.length>>"+dateNameArray.length);
                String timeName = dateNameArray[0];
                System.out.println("【日期名称（不包含图片扩展名）】"+timeName);
                String newDateName = dateUtil.formatLongTimeToImageName(Long.parseLong(timeName));
                System.out.println("【新时间名称】"+newDateName);
                String newFileName = camera+"_"+newDateName+".jpg";
                System.out.println("【新文件名称】"+newFileName);
                String newImgPath = imgPath.replace(fileName,"")+camera+"/"+newFileName;
                System.out.println("【fileName】 "+fileName);
                System.out.println("[newImgPath] "+newImgPath+" 【imgPath】"+imgPath);
                String newRelativePath = relativePath.replace(fileName,"")+camera+"/"+newFileName;
                System.out.println("[newRelativePath] "+newRelativePath+" 【relativePath】"+relativePath);

                File file = new File(imgPath);
                if(file.exists()){
                    System.out.println("该文件存在路径是："+imgPath);
                    // 对图片重命名
                    file.renameTo(new File(newImgPath));
                    // 重置属性
                    imageEntity.setFileName(newFileName);
                    imageEntity.setImgPath(newImgPath);
                    imageEntity.setRelativePath(newRelativePath);
                    return true;
                }else{
                    System.out.println("【"+fileName+"】该文件不存在");
                    return false;
                }
            }else{
                System.out.println("【"+fileName+"】该文件名不需要更新");
                return false;8
            }

        }else{
            // 已经分摄像头保存的图片
            String[] fileArray = fileName.split("_");
            if(fileArray.length==2){
                String dateName = fileArray[1];
                System.out.println("【日期名称（包含图片扩展名）】"+dateName);
                String[] dateNameArray = dateName.split("\\.");
                System.out.println("dateNameArray.length>>"+dateNameArray.length);
                String timeName = dateNameArray[0];
                System.out.println("【日期名称（不包含图片扩展名）】"+timeName);
                String newDateName = dateUtil.formatLongTimeToImageName(Long.parseLong(timeName));
                System.out.println("【新时间名称】"+newDateName);
                String newFileName = camera+"_"+newDateName+".jpg";
                System.out.println("【新文件名称】"+newFileName);
                String newImgPath = imgPath.replace(fileName,newFileName);
                System.out.println("【fileName】 "+fileName);
                System.out.println("[newImgPath] "+newImgPath+" 【imgPath】"+imgPath);
                String newRelativePath = relativePath.replace(fileName,newFileName);
                System.out.println("[newRelativePath] "+newRelativePath+" 【relativePath】"+relativePath);

                File file = new File(imgPath);
                if(file.exists()){
                    System.out.println("该文件存在路径是："+imgPath);
                    // 对图片重命名
                    file.renameTo(new File(newImgPath));
                    // 重置属性
                    imageEntity.setFileName(newFileName);
                    imageEntity.setImgPath(newImgPath);
                    imageEntity.setRelativePath(newRelativePath);
                    return true;
                }else{
                    System.out.println("【"+fileName+"】该文件不存在");
                    return false;
                }
            }else{
                System.out.println("【"+fileName+"】该文件名不需要更新");
                return false;
            }
        }
    }

    /**
     * @Method : getLastImage
     * @Description : 读取最后一幅图像
     * @Params : []
     * @Return : java.lang.String
     * @Author : ZhuoNing
     * @Date : 2021/1/21
     * @Time : 20:49
     */
    @Override
    public ImagePathEntity getLastImage() {
        // 读取最后一幅图像
        ImagePathEntity imagePathEntity = imagePathRepo.getLastImage();
        return imagePathEntity;
    }

    /**
     * @Method : getNextImage
     * @Description : 读取下一副图像
     * @Params : []
     * @Return : java.lang.String
     * @Author : ZhuoNing
     * @Date : 2021/1/21
     * @Time : 20:49
     */
    @Override
    public ImagePathEntity getNextImage() {
        // 读取下一副图像
        ImagePathEntity imagePathEntity = imagePathRepo.getNextImage();
        if (imagePathEntity != null) {
            // 更改记录
            imagePathEntity.setEffective(0);
            imagePathRepo.saveAndFlush(imagePathEntity);
            return imagePathEntity;
        } else {
            return imagePathRepo.getLastImage();
        }
    }

    /**
     * @Method : getImageList
     * @Description :
     * @Params : [startDate, endDate, pageNo, pageSize]
     * @Return : java.util.List<com.huimv.manager.dao.entity.ImagePathEntity>
     * @Author : ZhuoNing
     * @Date : 2021/1/22
     * @Time : 16:50
     */
    @Override
    public List<ImagePathEntity> getImageList(String startDate, String endDate, int pageNo, int pageSize, String catalog) {
        int start = (pageNo - 1) * pageSize;
        if (catalog != null && !catalog.isEmpty()) {
            // 按照日期区间，读取图片列表
            return imagePathRepo.listImage(startDate, endDate, start, pageSize, catalog);
        } else {
            // 按照日期区间，读取图片列表
            return imagePathRepo.listImage(startDate, endDate, start, pageSize);
        }
    }

    /**
     * @Method : getTotal
     * @Description :
     * @Params : [startDate, endDate]
     * @Return : int
     * @Author : ZhuoNing
     * @Date : 2021/1/22
     * @Time : 16:50
     */
    @Override
    public int getTotal(String startDate, String endDate, String catalog) {
        // 根据条件读取总记录数
        return imagePathRepo.getTotal(startDate, endDate, catalog);
    }

    @Override
    public int getTotal(String startDate, String endDate) {
        // 根据条件读取总记录数
        return imagePathRepo.getTotal(startDate, endDate);
    }

    @Override
    public List<ImagePathEntity> getExportImageList(String startDate, String endDate, String imageIds) {
        // 以指定图片导出优先条件
        if (imageIds == null || imageIds.trim().isEmpty()) {
            // 用startDate,endDate读取需要导出的图片
            return imagePathRepo.getExportImageListByStartAndEndDate(startDate, endDate);
        } else {
            // 指定需要导出的图片
            String[] idArray = imageIds.split(",");
            List imageIdList = new ArrayList();
            for (String id : idArray) {
                imageIdList.add(id);
            }
            // 读取导出图片
            return imagePathRepo.getExportImageListById(imageIdList);
        }
    }

    @Override
    public List<ImagePathEntity> getExportImageList(String startDate, String endDate, String imageIds, String catalog) {
        // 以指定图片导出优先条件
        if (imageIds == null || imageIds.trim().isEmpty()) {
            // 用startDate,endDate读取需要导出的图片
            return imagePathRepo.getExportImageListByStartAndEndDate(startDate, endDate, catalog);
        } else {
            // 指定需要导出的图片
            String[] idArray = imageIds.split(",");
            List imageIdList = new ArrayList();
            for (String id : idArray) {
                imageIdList.add(id);
            }
            // 读取导出图片
            return imagePathRepo.getExportImageListById(imageIdList);
        }
    }

    @Override
    public ImagePathEntity getOneImage(String type, int imageId, String catalog) {
        if (catalog == null || catalog.trim().isEmpty()) {
            if (type.trim().equalsIgnoreCase("next")) {
                // 读取下一张照片
                return imagePathRepo.getNextImageById(imageId);
            } else {
                // 读取上一张照片
                return imagePathRepo.getPreviousImageById(imageId);
            }
        } else {
            if (type.trim().equalsIgnoreCase("next")) {
                // 读取下一张照片
                return imagePathRepo.getNextImageById(imageId,catalog);
            } else {
                // 读取上一张照片
                return imagePathRepo.getPreviousImageById(imageId,catalog);
            }
        }
    }

    @Override
    public ImagePathEntity getOneImageDetail(String imageId) {
        //
        return imagePathRepo.getOneImageById(imageId);
    }
}
